#include "../../../lib/std.mi"
#include "utility.m"

Global Layout layoutParent;
Global Group groupScript;
Global Group groupAboutNormalTitlebar;
Global Button buttonAboutRPC;
Global Button buttonAbout883;
Global Button buttonAboutBreed;
Global GuiObject textAboutVersion;
Global GuiObject textAboutThanks1;
Global GuiObject textAboutThanks2;
Global GuiObject textAboutCopyright;
Global GuiObject textAboutCurrent;
Global GuiObject textAboutNext;
Global Float fltTransitionSpeedFast;
Global Float fltTransitionSpeedSlow;
Global Timer timerPause;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	layoutParent = groupScript.getParentLayout();
	if (layoutParent != NULL) {
		groupAboutNormalTitlebar = layoutParent.findObject("about.titlebar");
		Int intLayoutW = System.stringToInteger(layoutParent.getXMLParam("default_w"));
		groupAboutNormalTitlebar.setXMLParam("x", System.integerToString((intLayoutW / 2) - (groupAboutNormalTitlebar.getWidth() / 2)));
	}
	
	buttonAboutRPC = groupScript.findObject("about.button.rpeterclark").findObject("fadebutton.button");
	buttonAbout883 = groupScript.findObject("about.button.883").findObject("fadebutton.button");
	buttonAboutBreed = groupScript.findObject("about.button.breed").findObject("fadebutton.button");
	
	textAboutVersion = groupScript.findObject("about.version");
	textAboutThanks1 = groupScript.findObject("about.thanks.1");
	textAboutThanks2 = groupScript.findObject("about.thanks.2");
	textAboutCopyright = groupScript.findObject("about.copyright");
	
	fltTransitionSpeedFast = 0.25;
	fltTransitionSpeedSlow = 0.75;
	
	timerPause = new Timer;
	timerPause.setDelay(5000);
	
	textAboutVersion.setAlpha(0);
	textAboutThanks1.setAlpha(0);
	textAboutThanks2.setAlpha(0);
	textAboutCopyright.setAlpha(0);
	
	animateGuiObjectAlpha(textAboutVersion, 255, fltTransitionSpeedFast);
}

buttonAboutRPC.onLeftClick() { System.navigateURL("http://www.rpeterclark.com/"); }
buttonAbout883.onLeftClick() { System.navigateURL("http://883.breedart.org/"); }
buttonAboutBreed.onLeftClick() { System.navigateURL("http://www.breedart.org/"); }

timerPause.onTimer() {
	timerPause.stop();
	animateGuiObjectAlpha(textAboutCurrent, 0, fltTransitionSpeedFast);
	animateGuiObjectAlpha(textAboutNext, 255, fltTransitionSpeedSlow);
}

textAboutVersion.onTargetReached() {
	if (textAboutVersion.getAlpha() == 255) {
		textAboutCurrent = textAboutVersion;
		textAboutNext = textAboutThanks1;
		timerPause.start();
	}
}

textAboutThanks1.onTargetReached() {
	if (textAboutThanks1.getAlpha() == 255) {
		textAboutCurrent = textAboutThanks1;
		textAboutNext = textAboutThanks2;
		timerPause.start();
	}
}

textAboutThanks2.onTargetReached() {
	if (textAboutThanks2.getAlpha() == 255) {
		textAboutCurrent = textAboutThanks2;
		textAboutNext = textAboutCopyright;
		timerPause.start();
	}
}

textAboutCopyright.onTargetReached() {
	if (textAboutCopyright.getAlpha() == 255) {
		textAboutCurrent = textAboutCopyright;
		textAboutNext = textAboutVersion;
		timerPause.start();
	}
}