//--------------------------------------------------------------------------------------------------
// AutoRepeatButton.m	 Orginal Code By Will Fisher, Concept By Eric Moore, Rewritten By Will Fisher
//
// Use like this:
// #include </lib/AutoRepeatButton.m>
// Global AutoRepeatButton MyButton, MyOtherButton; 
// 
// Fill in the buttons function into MyButton.OnLeftClick() as normal.
//
// Use AutoRepeat_ClickType to find the type of call to MyButton.onLeftClick() where
//	 AutoRepeat_ClickType==1 is the first call to onLeftClick
//	 AutoRepeat_ClickType==2 is a subsequent call to onLeftClick
//	 AutoRepeat_ClickType==0 is an erronious call to onLeftClick, you should usually ignore
//													 MyButton.onLeftClick() in this case
// See other functions below:
//--------------------------------------------------------------------------------------------------

Function AutoRepeat_Load();
Function AutoRepeat_Unload();
Function AutoRepeat_Stop();

Function Button AutoRepeat_GetCurrentButton();
Function AutoRepeat_SetInitalDelay(int millis); 
Function AutoRepeat_SetRepeatDelay(int millis);
Function Int AutoRepeat_GetInitalDelay();
Function Int AutoRepeat_GetRepeatDelay();

Class Button AutoRepeatButton;

Global Timer _autorepeatTimer;
Global Int _InitialDelay;
Global Int _RepeatDelay;
Global Int AutoRepeat_ClickType;
Global Button _Latched;

AutoRepeatButton.onLeftButtonDown(int x, int y) {
	_Latched = AutoRepeatButton;
	AutoRepeat_ClickType = 1;
	AutoRepeatButton.leftClick();
	AutoRepeat_ClickType = 0;
	_autorepeatTimer.setDelay(_InitialDelay);
	_autorepeatTimer.start();
}

AutoRepeatButton.onLeftButtonUp(int x, int y) {
	_AutoRepeatTimer.Stop();
	_Latched = NULL;
}

_AutoRepeatTimer.onTimer() {
	if(_autorepeatTimer.getDelay() != _RepeatDelay) _autorepeatTimer.setDelay(_RepeatDelay);
	AutoRepeat_ClickType = 2; // AutoRepeat
	_Latched.LeftClick();
	AutoRepeat_ClickType = 0; // no click
}

AutoRepeat_Load() {
	_autoRepeatTimer = new Timer;
	_InitialDelay = 300;
	_RepeatDelay = 10;
	AutoRepeat_ClickType = 0;
}

AutoRepeat_Unload() {
	delete _autoRepeatTimer;
}

AutoRepeat_SetInitalDelay(int millis) {
	_InitialDelay = millis;
}


AutoRepeat_SetRepeatDelay(int millis) {
	_RepeatDelay = millis;
}

AutoRepeat_GetInitalDelay() {
	return _InitialDelay;
}

AutoRepeat_GetRepeatDelay() {
	return _repeatDelay;
}

AutoRepeat_Stop() {
	_autorepeatTimer.stop();
	_Latched = NULL;
}

AutoRepeat_GetCurrentButton() {
	return _Latched;
}
