Function initBehaviors();
Function unloadBehaviors();
Function setTextScrolling(Boolean boolScroll);
Function dimDisplay(Boolean boolDim, Boolean boolAnimate);
Function hideDisplay(Boolean boolHide);
Function setPlayPuase(Int intMode);
Function setShadeLink(Boolean boolLink);
Function setCoverArt(String strPlayItemTitle);
Function buttonSwitchClickUtil();

Global Button buttonMainNormalPlayPause;
Global Button buttonMainNormalStop;
Global Button buttonMainNormalNext;
Global Button buttonMainNormalPrev;

Global AutoRepeatButton buttonMainNormalVolumeUp;
Global AutoRepeatButton buttonMainNormalVolumeDown;

Global AnimatedLayer layerMainNormalIntro;
Global AnimatedLayer layerMainCompactIntro;

Global Group groupMainNormalTime;
Global Group groupMainCompactTime;
Global Group groupMainShadeTime;

Global Layer layerMainNormalDrawerRadiosity1;
Global Layer layerMainNormalDrawerRadiosity2;

Global Button buttonMainNormalSkinOptions;
Global Button buttonMainCompactSkinOptions;
Global Button buttonMainShadeSkinOptions;

Global Button buttonMainNormalSwitch;
Global Button buttonMainCompactSwitch;
Global Button buttonMainShadeSwitch;

Global Button buttonCoverArtToggleSize;
Global Int intLayoutCoverArtWidth;
Global Int intLayoutCoverArtHeight;

Global Timer timerPausePulse;

Global Togglebutton buttonAVSNormalRandom;
Global Layer layerAVSNormalRandomLED;

initBehaviors() {
	AutoRepeat_Load();
	
	buttonMainNormalSkinOptions = layoutMainNormal.findObject("player.button.options");
	buttonMainCompactSkinOptions = layoutMainCompact.findObject("player.button.options");
	buttonMainShadeSkinOptions = layoutMainShade.findObject("player.button.options");

	layerMainNormalIntro = layoutMainNormal.findObject("player.intro");
	layerMainCompactIntro = layoutMainCompact.findObject("player.intro");

	groupMainNormalTime = layoutMainNormal.findObject("player.normal.group.drawer.time");
	groupMainCompactTime = layoutMainCompact.findObject("player.compact.group.time");
	groupMainShadeTime = layoutMainShade.findObject("player.shade.group.time");
	
	layerMainNormalDrawerRadiosity1 = layoutMainNormal.findObject("player.background.drawer.radiosity.1");
	layerMainNormalDrawerRadiosity2 = layoutMainNormal.findObject("player.background.drawer.radiosity.2");
	
	buttonMainNormalPlayPause = layoutMainNormal.findObject("player.button.playpause");
	buttonMainNormalStop = layoutMainNormal.findObject("player.button.stop");
	buttonMainNormalNext = layoutMainNormal.findObject("player.button.next");
	buttonMainNormalPrev = layoutMainNormal.findObject("player.button.prev");
	
	buttonMainNormalVolumeUp = layoutMainNormal.findObject("player.button.volume.up");
	buttonMainNormalVolumeDown = layoutMainNormal.findObject("player.button.volume.down");
	
	buttonMainNormalSwitch = layoutMainNormal.findObject("player.button.switch");
	buttonMainCompactSwitch = layoutMainCompact.findObject("player.button.switch");
	buttonMainShadeSwitch = layoutMainShade.findObject("player.button.switch");
	
	buttonCoverArtToggleSize = layoutCoverArtNormal.findObject("button.togglesize");
	intLayoutCoverArtWidth = layoutCoverArtNormal.getWidth();
	intLayoutCoverArtHeight = layoutCoverArtNormal.getHeight();
	
	timerPausePulse = new Timer;
	timerPausePulse.setDelay(200);

	buttonAVSNormalRandom = layoutAVSNormal.findObject("avs.button.random");
	layerAVSNormalRandomLED = layoutAVSNormal.findObject("avs.background.random.led");

	hideDisplay(true);
	setTextScrolling(configAttribute_textScrolling.getData() == "1");
	if (System.getStatus() == -1) { timerPausePulse.start(); }
	if (System.getStatus() == 1) { timerSongInfo.start(); }
	setShadeLink(configAttribute_unlinkShadePosition.getData() == "1");
	buttonAVSNormalRandom.onToggle(buttonAVSNormalRandom.getActivated());
	
	setCoverArt(System.getPlayItemString());
	
	layerMainNormalIntro.show();
	layerMainCompactIntro.show();
	layerMainNormalIntro.play();
	layerMainCompactIntro.play();
}

unloadBehaviors() {
	AutoRepeat_Unload();
	timerPausePulse.stop();
	delete timerPausePulse;
}

layerMainNormalIntro.onStop() {
	layerMainNormalIntro.hide();
	layerMainCompactIntro.hide();
	hideDisplay(false);
	dimDisplay(false, true);
	setPlayPuase(System.getStatus());
}

dimDisplay(Boolean boolDim, Boolean boolAnimate) {
	Float fltDimSpeed = 0.75;
	
	if (boolDim) {
		if (boolAnimate) {
			animateGuiObjectAlpha(groupMainNormalTime, 128, fltDimSpeed);
			animateGuiObjectAlpha(layerMainNormalDrawerRadiosity1, 192, fltDimSpeed);
			animateGuiObjectAlpha(layerMainNormalDrawerRadiosity2, 192, fltDimSpeed);
			animateGuiObjectAlpha(groupMainCompactTime, 128, fltDimSpeed);
			animateGuiObjectAlpha(groupMainShadeTime, 128, fltDimSpeed);
		} else {
			groupMainNormalTime.setAlpha(128);
			layerMainNormalDrawerRadiosity1.setAlpha(192);
			layerMainNormalDrawerRadiosity2.setAlpha(192);
			groupMainCompactTime.setAlpha(128);
			groupMainShadeTime.setAlpha(128);
		}
	} else {
		if (boolAnimate) {
			animateGuiObjectAlpha(groupMainNormalTime, 255, fltDimSpeed);
			animateGuiObjectAlpha(layerMainNormalDrawerRadiosity1, 255, fltDimSpeed);
			animateGuiObjectAlpha(layerMainNormalDrawerRadiosity2, 255, fltDimSpeed);
			animateGuiObjectAlpha(groupMainCompactTime, 255, fltDimSpeed);
			animateGuiObjectAlpha(groupMainShadeTime, 255, fltDimSpeed);
		} else {
			groupMainNormalTime.setAlpha(255);
			layerMainNormalDrawerRadiosity1.setAlpha(255);
			layerMainNormalDrawerRadiosity2.setAlpha(255);
			groupMainCompactTime.setAlpha(255);
			groupMainShadeTime.setAlpha(255);
		}
	}
}

hideDisplay(Boolean boolHide) {
	if (boolHide) {
		groupMainNormalTime.hide();
		groupMainCompactTime.hide();
	} else {
		groupMainNormalTime.show();
		groupMainCompactTime.show();
	}
}

timerPausePulse.ontimer() {
	if (groupMainNormalTime.getAlpha() < 255) {
		dimDisplay(false, false);
	} else {
		dimDisplay(true, false);
	}
}

System.onPlay() {
	timerSeek.start();
	setPlayPuase(1);
	timerPausePulse.stop();
	dimDisplay(false, true);
	timerSongInfo.setDelay(50);
	timerSongInfo.start();
}

System.onStop() {
	timerSeek.stop();
	setPlayPuase(0);
	timerPausePulse.stop();
	setSeekAnimation(0, layerMainNormalSeek);
	setSeekAnimation(0, layerMainCompactSeek);
	timerSongInfo.stop();
	displayEmptySongInfo();
}

System.onPause() {
	setPlayPuase(-1);
	timerPausePulse.start();
	timerSongInfo.stop();
}

System.onResume() {
	setPlayPuase(1);
	timerPausePulse.stop();
	dimDisplay(false, true);
	timerSongInfo.setDelay(50);
	timerSongInfo.start();
}

System.onVolumeChanged(Int intVolume) {
	showActionInfo("Volume: " + System.integerToString((System.getVolume() / 255) * 100) + "%");
	volumeUpdate();
}

System.onTitleChange(String strNewTitle) {
	setCoverArt(strNewTitle);
}

setPlayPuase(Int intMode) {
	if (intMode == 1) {
		buttonMainNormalPlayPause.setXMLParam("action", "Pause");
		buttonMainNormalPlayPause.setXMLParam("tooltip", "Pause");
	} else if (intMode == -1 || intMode == 0) {
		buttonMainNormalPlayPause.setXMLParam("action", "Play");
		buttonMainNormalPlayPause.setXMLParam("tooltip", "Play");
	}
}

configAttribute_textScrolling.onDataChanged() {
	setTextScrolling(configAttribute_textScrolling.getData() == "1");
}

configAttribute_unlinkShadePosition.onDataChanged() {
	setShadeLink(configAttribute_unlinkShadePosition.getData() == "1");
}

buttonMainNormalVolumeUp.onLeftClick() {
	if (AutoRepeat_ClickType != 0) {
		Int intNewVolume = System.getVolume() + 5;
		if (intNewVolume > 255) {
			intNewVolume = 255;
			showActionInfo("Volume: " + System.integerToString((System.getVolume() / 255) * 100) + "%");
		}
		System.SetVolume(intNewVolume);
	}
}

buttonMainNormalVolumeDown.onLeftClick() {
	if (AutoRepeat_ClickType != 0) {
		Int intNewVolume = System.getVolume() - 5;
		if (intNewVolume < 0) {
			intNewVolume = 0;
			showActionInfo("Volume: " + System.integerToString((System.getVolume() / 255) * 100) + "%");
		}
		System.SetVolume(intNewVolume);
	}
}

buttonMainNormalSkinOptions.onLeftClick() { showSkinOptionsMenu(); }
buttonMainCompactSkinOptions.onLeftClick() { showSkinOptionsMenu(); }
buttonMainShadeSkinOptions.onLeftClick() { showSkinOptionsMenu(); }

setTextScrolling(Boolean boolScroll) {
	textNormalSongInfo.setXMLParam("ticker", System.integerToString(boolScroll));
	textCompactSongInfo.setXMLParam("ticker", System.integerToString(boolScroll));
	textShadeSongInfo.setXMLParam("ticker", System.integerToString(boolScroll));
	textPLShadeSongInfo.setXMLParam("ticker", System.integerToString(boolScroll));
}

setShadeLink(Boolean boolLink) {
	layoutMainShade.setXMLParam("unlinked", System.integerToString(boolLink));
}

buttonAVSNormalRandom.onLeftButtonDown(Int intPosX, Int intPosY) { layerAVSNormalRandomLED.hide(); }
buttonAVSNormalRandom.onToggle(Boolean boolActivated) {
	if (boolActivated) {
		layerAVSNormalRandomLED.setAlpha(0);
		layerAVSNormalRandomLED.show();
		animateGuiObjectAlpha(layerAVSNormalRandomLED, 255, 0.5);
	} else {
		layerAVSNormalRandomLED.hide();
	}
}

buttonMainNormalSwitch.onRightClick() { buttonSwitchClickUtil(); }
buttonMainCompactSwitch.onRightClick() { buttonSwitchClickUtil(); }
buttonMainShadeSwitch.onRightClick() { buttonSwitchClickUtil(); }

buttonMainNormalSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete; }
buttonMainCompactSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete; }
buttonMainShadeSwitch.onRightButtonUp(Int intPosX, Int intPosY) { complete; }

buttonSwitchClickUtil() {
	PopupMenu popupMenuSwitch;
	
	popupMenuSwitch = new PopupMenu;
	popupMenuSwitch.addCommand("Select Mode: ", 0, 0, 1);
	popupMenuSwitch.addSeparator();
	popupMenuSwitch.addCommand("Normal ", 1, (layoutMainNormal.isVisible()), 0);
	popupMenuSwitch.addCommand("Pad ", 2, (layoutMainCompact.isVisible()), 0);
	popupMenuSwitch.addCommand("Shade ", 3, (layoutMainShade.isVisible()), 0);
	
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 1);
	Int intSelection = popupMenuSwitch.popAtMouse();
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 0);
	
	if (intSelection > 0) {
		if (intSelection == 1) { containerMain.switchToLayout("NORMAL"); }
		if (intSelection == 2) { containerMain.switchToLayout("COMPACT"); }
		if (intSelection == 3) { containerMain.switchToLayout("SHADE"); }
	}
	
	delete popupMenuSwitch;
	complete;
}

buttonCoverArtToggleSize.onLeftClick() {
	Int intSizeLargeW = 256;
	Int intSizeLargeH = 279;
	Int intSizeSmallW = 150;
	Int intSizeSmallH = 173;
	Float fltTargetSpeed = 0.5;
	
	if (layoutCoverArtNormal.getWidth() * layoutCoverArtNormal.getHeight() <= 25950) {
		layoutCoverArtNormal.setTargetX(layoutCoverArtNormal.getLeft() - ((intSizeLargeW - layoutCoverArtNormal.getWidth()) / 2));
		layoutCoverArtNormal.setTargetY(layoutCoverArtNormal.getTop() - ((intSizeLargeH - layoutCoverArtNormal.getHeight()) / 2));
		layoutCoverArtNormal.setTargetW(intSizeLargeW);
		layoutCoverArtNormal.setTargetH(intSizeLargeH);
		layoutCoverArtNormal.setTargetSpeed(fltTargetSpeed);
		layoutCoverArtNormal.gotoTarget();
	} else {
		layoutCoverArtNormal.setTargetX(layoutCoverArtNormal.getLeft() - ((intSizeSmallW - layoutCoverArtNormal.getWidth()) / 2));
		layoutCoverArtNormal.setTargetY(layoutCoverArtNormal.getTop() - ((intSizeSmallH - layoutCoverArtNormal.getHeight()) / 2));
		layoutCoverArtNormal.setTargetW(intSizeSmallW);
		layoutCoverArtNormal.setTargetH(intSizeSmallH);
		layoutCoverArtNormal.setTargetSpeed(fltTargetSpeed);
		layoutCoverArtNormal.gotoTarget();
	}
}

layoutCoverArtNormal.onTargetReached() {
	intLayoutCoverArtWidth = layoutCoverArtNormal.getWidth();
	intLayoutCoverArtHeight = layoutCoverArtNormal.getHeight();
}

layoutCoverArtNormal.onUserResize(Int intX, Int intY, Int intW, Int intH) {
	if (intW != (intH - 23)) {
		if (intW != intLayoutCoverArtWidth) layoutCoverArtNormal.resize(intX, intY, intW, (intW + 23));
		if (intH != intLayoutCoverArtHeight) layoutCoverArtNormal.resize(intX, intY, (intH - 23), intH);
	}
	intLayoutCoverArtWidth = layoutCoverArtNormal.getWidth();
	intLayoutCoverArtHeight = layoutCoverArtNormal.getHeight();
}

setCoverArt(String strPlayItemTitle) {
	Map mapCover = new Map;
	String strFileLocation = System.getPlayItemString();
	String strCoverFileNames = "cover.jpg;coverart.jpg;folder.jpg;front.jpg";
	String strCoverFileName = "";
	String strCoverFilePath = "";
	
	if (strFileLocation != "") {
		if (System.strSearch(strFileLocation, "file://") > -1) {
			strFileLocation = System.strLeft(strFileLocation, System.strSearch(strFileLocation, System.removePath(strFileLocation)));
			strFileLocation = System.strRight(strFileLocation, System.strLen(strFileLocation) - (System.strSearch(strFileLocation, "//") + 2));
			
			Int intTokenCount = strCharCount(strCoverFileNames, ";");
		
			for (Int i = 0; i <= intTokenCount; i++) {
				if (strCoverFilePath == "") {
					strCoverFilename = System.getToken(strCoverFileNames, ";", i);
					mapCover.loadMap(strFileLocation + strCoverFileName);
					if (mapCover.getValue(0, 0) > 0) strCoverFilePath = strFileLocation + strCoverFileName;
				}
			}
		}
	}
	
	configAttribute_coverArtFilePath.setData(strCoverFilePath);
	delete mapCover;
}
