#include "../../../lib/std.mi"
#include "utility.m"

Function setButtonStatusLED(Int intStatus);

Global Group groupScript;
Global Layout layoutParent;
Global Button buttonParent;
Global Group groupButtonGlow;
Global Group groupButtonSuperGlow;
Global Group groupButtonDownGlow;
Global String strButtonGlowPrefix;
Global String strButtonAction;
Global String strButtonBehaviorType;
Global Float fltFadeInSpeed;
Global Float fltFadeOutSpeed;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	layoutParent = groupScript.getParentLayout();
	groupButtonGlow = groupScript.findObject("buttonled.group.glow");
	groupButtonSuperGlow = groupScript.findObject("buttonled.group.superglow");
	groupButtonDownGlow = groupScript.findObject("buttonled.group.downglow");
	
	fltFadeInSpeed = 0.25;
	fltFadeOutSpeed = 0.75;
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "parent") { buttonParent = layoutParent.findObject(strValue); }
	if (System.strLower(strParam) == "prefix") { strButtonGlowPrefix = strValue; }
	if (System.strLower(strParam) == "action") { strButtonAction = System.strUpper(strValue); }
	if (System.strLower(strParam) == "behaviortype") { strButtonBehaviorType = System.strUpper(strValue); }
	
	if (buttonParent != NULL && strButtonGlowPrefix != "" && strButtonBehaviorType != "") {
		if (strButtonBehaviorType == "0") {
			groupScript.findObject("buttonled.glow").setXMLParam("image", strButtonGlowPrefix + ".glow");
			groupButtonGlow.setAlpha(0);
		}
		if (strButtonBehaviorType == "1") {
			groupScript.findObject("buttonled.glow").setXMLParam("image", strButtonGlowPrefix + ".glow");
			groupScript.findObject("buttonled.glow.extra").setXMLParam("image", strButtonGlowPrefix + ".glow.extra");
			groupScript.findObject("buttonled.superglow").setXMLParam("image", strButtonGlowPrefix + ".superglow");
			groupScript.findObject("buttonled.superglow.extra").setXMLParam("image", strButtonGlowPrefix + ".superglow.extra");
			groupScript.findObject("buttonled.downglow").setXMLParam("image", strButtonGlowPrefix + ".downglow");
			groupScript.findObject("buttonled.downglow.extra").setXMLParam("image", strButtonGlowPrefix + ".downglow.extra");
			groupButtonSuperGlow.setAlpha(0);
			groupButtonDownGlow.hide();
		}
		setButtonStatusLED(System.getStatus());
	}
}

buttonParent.onEnterArea() {
	if (strButtonBehaviorType == "0") {
		animateGuiObjectAlpha(groupButtonGlow, 255, fltFadeInSpeed);
	}
	if (strButtonBehaviorType == "1") {
		animateGuiObjectAlpha(groupButtonSuperGlow, 255, fltFadeInSpeed);
	}
}

buttonParent.onLeaveArea() {
	if (strButtonAction != "") {
		setButtonStatusLED(System.getStatus());
	} else {
		if (strButtonBehaviorType == "0") {
			animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
		}
		if (strButtonBehaviorType == "1") {
			animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
		}
	}
}

buttonParent.onLeftButtonDown(Int intX, Int intY) {
	if (strButtonBehaviorType == "0") {
		groupButtonGlow.hide();
	}
	if (strButtonBehaviorType == "1") {
		groupButtonDownGlow.show();
		groupButtonGlow.hide();
		groupButtonSuperGlow.hide();
	}
}

buttonParent.onLeftButtonUp(Int intX, Int intY) {
	if (strButtonBehaviorType == "0") {
		groupButtonGlow.show();
	}
	if (strButtonBehaviorType == "1") {
		groupButtonGlow.show();
		groupButtonSuperGlow.show();
		groupButtonDownGlow.hide();
	}
}

System.onPlay() {
	setButtonStatusLED(1);
}

System.onPause() {
	setButtonStatusLED(-1);
}

System.onStop() {
	setButtonStatusLED(0);
}

System.onResume() {
	setButtonStatusLED(1);
}

setButtonStatusLED(Int intStatus) {
	if (intStatus == -1) {
		if (strButtonBehaviorType == "0") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonGlow, 255, fltFadeInSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			}
		}
		if (strButtonBehaviorType == "1") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 255, fltFadeInSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			}
		}
	} else if (intStatus == 0) {
		if (strButtonBehaviorType == "0") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonGlow, 255, fltFadeInSpeed);
			}
		}
		if (strButtonBehaviorType == "1") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 255, fltFadeInSpeed);
			}
		}
	} else if (intStatus == 1) {
		if (strButtonBehaviorType == "0") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonGlow, 255, fltFadeInSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonGlow, 0, fltFadeOutSpeed);
			}
		}
		if (strButtonBehaviorType == "1") {
			if (strButtonAction == "PLAY") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 255, fltFadeInSpeed);
			} else if (strButtonAction == "PAUSE") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			} else if (strButtonAction == "STOP") {
				animateGuiObjectAlpha(groupButtonSuperGlow, 0, fltFadeOutSpeed);
			}
		}
	}
}