Function initConfig();
Function setConfigDisplay(Int intState);
Function setConfigDisplayOptions(Int intState);
Function setConfigDisplaySize(Int intState);

Global Group groupConfigNormalTitlebar;
Global Group groupConfigEqualizer;
Global Group groupConfigOptions;
Global Group groupConfigOptionsGeneral;
Global Group groupConfigOptionsNotifications;
Global Group groupConfigColorThemes;
Global Group groupConfigEE;
Global Group groupConfigScanline;

Global Button buttonConfigNotificationsHoldtimeDecrease;
Global Button buttonConfigNotificationsHoldtimeIncrease;
Global Text textConfigNotificationsHoldtimeDisplay;

initConfig() {
	groupConfigNormalTitlebar = layoutConfigNormal.findObject("config.titlebar");
	groupConfigEqualizer = layoutConfigNormal.findObject("config.display.equalizer");
	groupConfigOptions = layoutConfigNormal.findObject("config.display.options");
	groupConfigOptionsGeneral = layoutConfigNormal.findObject("config.display.options.general");
	groupConfigOptionsNotifications = layoutConfigNormal.findObject("config.display.options.notifications");
	groupConfigColorThemes = layoutConfigNormal.findObject("config.display.colorthemes");
	groupConfigEE = layoutConfigNormal.findObject("config.ee");
	
	groupConfigScanline = layoutConfigNormal.findObject("config.scanline");
	
	buttonConfigNotificationsHoldtimeDecrease = layoutConfigNormal.findObject("config.button.notifications.holdtime.decrease");
	buttonConfigNotificationsHoldtimeIncrease = layoutConfigNormal.findObject("config.button.notifications.holdtime.increase");
	textConfigNotificationsHoldtimeDisplay = layoutConfigNormal.findObject("config.notifications.holdtime.display");
	
	groupConfigEqualizer.hide();
	groupConfigOptions.hide();
	groupConfigOptionsGeneral.hide();
	groupConfigOptionsNotifications.hide();
	groupConfigColorThemes.hide();
	groupConfigEE.hide();
	
	groupConfigScanline.hide();
	
	if (configAttribute_configStateEqualizer.getData() == "1") setConfigDisplay(0);
	if (configAttribute_configStateOptions.getData() == "1") {
		setConfigDisplay(1);
		if (configAttribute_configStateOptionsGeneral.getData() == "1") setConfigDisplayOptions(0);
		if (configAttribute_configStateOptionsNotifications.getData() == "1") setConfigDisplayOptions(1);
	}
	if (configAttribute_configStateColorThemes.getData() == "1") setConfigDisplay(2);
	if (configAttribute_eeState.getData() == "1") groupConfigEE.show();
	
	configAttribute_notifierHoldtime.setData(configAttribute_notifierHoldtime.getData());
}

layoutConfigNormal.onResize(Int intX, Int intY, Int intW, Int intH) {
	groupConfigNormalTitlebar.setXMLParam("x", System.integerToString((layoutConfigNormal.getWidth() / 2) - (groupConfigNormalTitlebar.getWidth() / 2)));
}

configAttribute_configStateEqualizer.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	if (configAttribute_configStateEqualizer.getData() == "1") {
		configAttribute_configStateOptions.setData("0");
		configAttribute_configStateColorThemes.setData("0");
		setConfigDisplay(0);
	}
	boolMyChange = false;
}

configAttribute_configStateOptions.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	if (configAttribute_configStateOptions.getData() == "1") {
		configAttribute_configStateEqualizer.setData("0");
		configAttribute_configStateColorThemes.setData("0");
		setConfigDisplay(1);
		if (configAttribute_configStateOptionsGeneral.getData() == "1") setConfigDisplayOptions(0);
		if (configAttribute_configStateOptionsNotifications.getData() == "1") setConfigDisplayOptions(1);
	}
	boolMyChange = false;
}

configAttribute_configStateColorThemes.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	if (configAttribute_configStateColorThemes.getData() == "1") {
		configAttribute_configStateEqualizer.setData("0");
		configAttribute_configStateOptions.setData("0");
		setConfigDisplay(2);
	}
	boolMyChange = false;
}

configAttribute_configStateOptionsGeneral.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	if (configAttribute_configStateOptionsGeneral.getData() == "1") {
		configAttribute_configStateOptionsNotifications.setData("0");
		setConfigDisplayOptions(0);
	}
	boolMyChange = false;
}

configAttribute_configStateOptionsNotifications.onDataChanged() {
	if (boolMyChange) return;
	NOOFF
	boolMyChange = true;
	if (configAttribute_configStateOptionsNotifications.getData() == "1") {
		configAttribute_configStateOptionsGeneral.setData("0");
		setConfigDisplayOptions(1);
	}
	boolMyChange = false;
}

configAttribute_eeState.onDataChanged() {
	if (configAttribute_eeState.getData() == "1") {
		groupConfigEE.show();
	} else {
		groupConfigEE.hide();
	}
}

setConfigDisplay(Int intState) {
	if (intState == 0) {
		groupConfigEqualizer.show();
		groupConfigOptions.hide();
		groupConfigColorThemes.hide();
		groupConfigScanline.show();
		setConfigDisplaySize(0);
	}
	
	if (intState == 1) {
		groupConfigEqualizer.hide();
		groupConfigOptions.show();
		groupConfigColorThemes.hide();
		groupConfigScanline.show();
		if (configAttribute_configStateOptionsGeneral.getData() == "1") setConfigDisplaySize(2);
		if (configAttribute_configStateOptionsNotifications.getData() == "1") setConfigDisplaySize(1);
	}
	
	if (intState == 2) {
		groupConfigEqualizer.hide();
		groupConfigOptions.hide();
		groupConfigColorThemes.show();
		groupConfigScanline.hide();
		setConfigDisplaySize(1);
	}
}

setConfigDisplayOptions(Int intState) {
	if (intState == 0) {
		groupConfigOptionsGeneral.show();
		groupConfigOptionsNotifications.hide();
		setConfigDisplaySize(2);
	}
	
	if (intState == 1) {
		groupConfigOptionsGeneral.hide();
		groupConfigOptionsNotifications.show();
		setConfigDisplaySize(1);
	}
}

setConfigDisplaySize(Int intState) {
	layoutConfigNormal.resize(layoutConfigNormal.getLeft(), layoutConfigNormal.getTop(), layoutConfigNormal.getWidth(), layoutConfigNormal.getHeight());

	layoutConfigNormal.setTargetX(layoutConfigNormal.getLeft());
	layoutConfigNormal.setTargetY(layoutConfigNormal.getTop());
	layoutConfigNormal.setTargetW(layoutConfigNormal.getWidth());
	
	if (intState == 0) layoutConfigNormal.setTargetH(186);
	if (intState == 1) layoutConfigNormal.setTargetH(390);
	if (intState == 2) layoutConfigNormal.setTargetH(340);
	
	layoutConfigNormal.setTargetSpeed(0.5);
	layoutConfigNormal.gotoTarget();
}

buttonConfigNotificationsHoldtimeIncrease.onLeftClick() {
	Int intNotifierHoldtime = System.stringToInteger(configAttribute_notifierHoldtime.getData());
	intNotifierHoldtime = intNotifierHoldtime + 1000;
	if (intNotifierHoldtime > 20000) intNotifierHoldtime = 20000;
	configAttribute_notifierHoldtime.setData(System.integerToString(intNotifierHoldtime));
}

buttonConfigNotificationsHoldtimeDecrease.onLeftClick() {
	Int intNotifierHoldtime = System.stringToInteger(configAttribute_notifierHoldtime.getData());
	intNotifierHoldtime = intNotifierHoldtime - 1000;
	if (intNotifierHoldtime < 0) intNotifierHoldtime = 0;
	configAttribute_notifierHoldtime.setData(System.integerToString(intNotifierHoldtime));
}

configAttribute_notifierHoldtime.onDataChanged() {
	Int intNotifierHoldtime = System.stringToInteger(configAttribute_notifierHoldtime.getData());
	textConfigNotificationsHoldtimeDisplay.setText(System.integerToString(intNotifierHoldtime / 1000) + " Seconds");
}