#include "../../../lib/std.mi"
#include "attribs.m"
#include "utility.m"

Function updateCover(String strCoverFilePath);

Global Group groupScript;
Global Layer layerCoverA;
Global Layer layerCoverB;
Global Float fltTransitionTime;

System.onScriptLoaded() {
	initAttribs();
	
	groupScript = System.getScriptGroup();
	layerCoverA = groupScript.findObject("cover.image.a");
	layerCoverB = groupScript.findObject("cover.image.b");
	
	fltTransitionTime = 0.5;
	
	updateCover(configAttribute_coverArtFilePath.getData());
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "transitiontime") fltTransitionTime = System.stringToFloat(strValue);
}

configAttribute_coverArtFilePath.onDataChanged() {
	updateCover(configAttribute_coverArtFilePath.getData());
}

updateCover(String strCoverFilePath) {
	if (strCoverFilePath != "") {
		if (layerCoverA.getXMLParam("image") != strCoverFilePath) {
			layerCoverB.setXMLParam("image", layerCoverA.getXMLParam("image"));
			layerCoverB.setAlpha(layerCoverA.getAlpha());
			layerCoverA.setXMLParam("image", strCoverFilePath);
			layerCoverA.setAlpha(0);
			animateGuiObjectAlpha(layerCoverA, 255, fltTransitionTime);
			animateGuiObjectAlpha(layerCoverB, 0, fltTransitionTime);
		}
	} else {
		layerCoverB.setXMLParam("image", layerCoverA.getXMLParam("image"));
		layerCoverB.setAlpha(layerCoverA.getAlpha());
		layerCoverA.setXMLParam("image", "common.background.empty");
		layerCoverA.setAlpha(0);
		animateGuiObjectAlpha(layerCoverB, 0, fltTransitionTime);
	}
}