Function initDrawers();
Function setMainNormalDrawerState(Int intDrawerState);
Function setMainCompactDrawerState(Int intDrawerState);

Global Group groupMainNormalDrawer;
Global Group groupMainNormalDrawerTop;
Global Group groupMainNormalDrawerBottom0;
Global Group groupMainNormalDrawerBottom1;
Global Group groupMainNormalDrawerSongInfo;
Global Group groupMainNormalDrawerVisualizers;
Global Button buttonMainNormalDrawer;
Global Int intMainNormalDrawerState;

Global Group groupMainCompactDrawerVisualizers;
Global Group groupMainCompactDrawerSongInfo;
Global Group groupMainCompactDrawerTop;
Global Button buttonMainCompactDrawer;
Global Int intMainCompactDrawerState;

initDrawers() {
	groupMainNormalDrawer = layoutMainNormal.findObject("player.normal.group.drawer");
	groupMainNormalDrawerTop = layoutMainNormal.findObject("player.normal.group.drawer.top");
	groupMainNormalDrawerBottom0 = layoutMainNormal.findObject("player.normal.group.drawer.bottom.0");
	groupMainNormalDrawerBottom1 = layoutMainNormal.findObject("player.normal.group.drawer.bottom.1");
	groupMainNormalDrawerSongInfo = layoutMainNormal.findObject("player.normal.group.drawer.songinfo");
	groupMainNormalDrawerVisualizers = layoutMainNormal.findObject("player.normal.group.drawer.visualizers");
	buttonMainNormalDrawer = layoutMainNormal.findObject("player.button.drawer");
	
	groupMainCompactDrawerVisualizers = layoutMainCompact.findObject("player.compact.group.visualizers");
	groupMainCompactDrawerSongInfo = layoutMainCompact.findObject("player.compact.group.songinfo");
	groupMainCompactDrawerTop = layoutMainCompact.findObject("player.compact.group.top");
	buttonMainCompactDrawer = layoutMainCompact.findObject("player.button.drawer");
	
	intMainNormalDrawerState = System.getPrivateInt(System.getSkinName(), "MainNormalDrawerState", 0);
	intMainCompactDrawerState = System.getPrivateInt(System.getSkinName(), "MainCompactDrawerState", 0);
	
	setMainNormalDrawerState(intMainNormalDrawerState);
	setMainCompactDrawerState(intMainCompactDrawerState);
}

configAttribute_showExtraInfo.onDataChanged() {
	setMainNormalDrawerState(intMainNormalDrawerState);
	setMainCompactDrawerState(intMainCompactDrawerState);
}

buttonMainNormalDrawer.onLeftClick() {
	setMainNormalDrawerState((intMainNormalDrawerState + 1) % 3);
}

setMainNormalDrawerState(Int intDrawerState) {
	Float fltAnimationSpeed = 0.5;
	if (configAttribute_drawersAnimate.getData() != "1") fltAnimationSpeed = 0;
	
	if (intDrawerState == 0) {
		if (System.stringToInteger(configAttribute_showExtraInfo.getData()) == 1) {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "80");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(80);
			groupMainNormalDrawer.setTargetH(205);
			groupMainNormalDrawerTop.setTargetH(118);
			groupMainNormalDrawerSongInfo.show();
			groupMainNormalDrawerSongInfo.setTargetA(255);
		} else {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "91");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(91);
			groupMainNormalDrawer.setTargetH(194);
			groupMainNormalDrawerTop.setTargetH(107);
			groupMainNormalDrawerSongInfo.setTargetA(0);
		}
		groupMainNormalDrawerVisualizers.setTargetA(0);
		groupMainNormalDrawerVisualizers.setTargetSpeed(0);
		groupMainNormalDrawerBottom1.setTargetA(0);
		groupMainNormalDrawerBottom0.show();
		groupMainNormalDrawerBottom0.setTargetA(255);
	} else if (intDrawerState == 1) {
		if (System.stringToInteger(configAttribute_showExtraInfo.getData()) == 1) {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "63");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(63);
			groupMainNormalDrawer.setTargetH(222);
			groupMainNormalDrawerTop.setTargetH(118);
			groupMainNormalDrawerSongInfo.show();
			groupMainNormalDrawerSongInfo.setTargetA(255);
		} else {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "74");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(74);
			groupMainNormalDrawer.setTargetH(211);
			groupMainNormalDrawerTop.setTargetH(107);
			groupMainNormalDrawerSongInfo.setTargetA(0);
		}
		groupMainNormalDrawerBottom0.setTargetA(0);
		groupMainNormalDrawerBottom1.show();
		groupMainNormalDrawerBottom1.setTargetA(255);
	} else {
		if (System.stringToInteger(configAttribute_showExtraInfo.getData()) == 1) {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "0");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(0);
			groupMainNormalDrawer.setTargetH(285);
			groupMainNormalDrawerTop.setTargetH(118);
			groupMainNormalDrawerSongInfo.show();
			groupMainNormalDrawerSongInfo.setTargetA(255);
		} else {
			if (configAttribute_drawersSnapAdjust.getData() == "1") {
				layoutMainNormal.beforeRedock();
				layoutMainNormal.setXMLParam("snapadjusttop", "11");
				layoutMainNormal.redock();
			}
			groupMainNormalDrawer.setTargetY(11);
			groupMainNormalDrawer.setTargetH(274);
			groupMainNormalDrawerTop.setTargetH(107);
			groupMainNormalDrawerSongInfo.setTargetA(0);
		}
		groupMainNormalDrawerBottom0.setTargetA(0);
		groupMainNormalDrawerBottom1.show();
		groupMainNormalDrawerBottom1.setTargetA(255);
	}
	groupMainNormalDrawer.setTargetSpeed(fltAnimationSpeed);
	groupMainNormalDrawerTop.setTargetSpeed(fltAnimationSpeed);
	groupMainNormalDrawerBottom0.setTargetSpeed(fltAnimationSpeed);
	groupMainNormalDrawerBottom1.setTargetSpeed(fltAnimationSpeed);
	groupMainNormalDrawerSongInfo.setTargetSpeed(fltAnimationSpeed);
	
	groupMainNormalDrawer.gotoTarget();
	groupMainNormalDrawerTop.gotoTarget();
	groupMainNormalDrawerBottom0.gotoTarget();
	groupMainNormalDrawerBottom1.gotoTarget();
	groupMainNormalDrawerSongInfo.gotoTarget();
	groupMainNormalDrawerVisualizers.gotoTarget();

	intMainNormalDrawerState = intDrawerState;
	System.setPrivateInt(System.getSkinName(), "MainNormalDrawerState", intMainNormalDrawerState);
}

groupMainNormalDrawer.onTargetReached() {
	if (intMainNormalDrawerState == 2) {
		groupMainNormalDrawerVisualizers.show();
		groupMainNormalDrawerVisualizers.setTargetA(255);
		groupMainNormalDrawerVisualizers.setTargetSpeed(0.5);
		groupMainNormalDrawerVisualizers.gotoTarget();
	}
}

groupMainNormalDrawerBottom0.onTargetReached() {
	if (groupMainNormalDrawerBottom0.getAlpha() == 0) {
		groupMainNormalDrawerBottom0.hide();
	}
}

groupMainNormalDrawerBottom1.onTargetReached() {
	if (groupMainNormalDrawerBottom1.getAlpha() == 0) {
		groupMainNormalDrawerBottom1.hide();
	}
}

groupMainNormalDrawerSongInfo.onTargetReached() {
	if (groupMainNormalDrawerSongInfo.getAlpha() == 0) {
		groupMainNormalDrawerSongInfo.hide();
	}
}

groupMainNormalDrawerVisualizers.onTargetReached() {
	if (groupMainNormalDrawerVisualizers.getAlpha() == 0) {
		groupMainNormalDrawerVisualizers.hide();
	}
}

buttonMainCompactDrawer.onLeftClick() {
	setMainCompactDrawerState((intMainCompactDrawerState + 1) % 2);
}

setMainCompactDrawerState(Int intDrawerState) {
	Float fltAnimationSpeed = 0.5;
	if (configAttribute_drawersAnimate.getData() != "1") fltAnimationSpeed = 0;
	
	layoutMainCompact.setTargetX(layoutMainCompact.getLeft());
	layoutMainCompact.setTargetY(layoutMainCompact.getTop());
	layoutMainCompact.setTargetW(layoutMainCompact.getWidth());
	
	Int intLayoutBaseHeight = 249;
	Int intGroupTopBaseHeight = 107;
	Int intGroupSongInfoHeight = 11;
	Int intGroupVisualizerHeight = 63;
	
	Int intLayoutHeight = intLayoutBaseHeight;
	Int intGroupTopHeight = intGroupTopBaseHeight;
	
	if (System.stringToInteger(configAttribute_showExtraInfo.getData()) == 1) {
		intLayoutHeight += intGroupSongInfoHeight;
		intGroupTopHeight += intGroupSongInfoHeight;
		groupMainCompactDrawerSongInfo.show();
		groupMainCompactDrawerSongInfo.setTargetA(255);
	} else {
		groupMainCompactDrawerSongInfo.setTargetA(0);
	}
	
	if (intDrawerState == 0) {
		groupMainCompactDrawerVisualizers.setAlpha(0);
		groupMainCompactDrawerVisualizers.hide();
	} else if (intDrawerState == 1) {
		intLayoutHeight += intGroupVisualizerHeight;
	}
	
	layoutMainCompact.setTargetH(intLayoutHeight);
	groupMainCompactDrawerTop.setTargetH(intGroupTopHeight);
	
	layoutMainCompact.setTargetSpeed(fltAnimationSpeed);
	groupMainCompactDrawerTop.setTargetSpeed(fltAnimationSpeed);
	groupMainCompactDrawerSongInfo.setTargetSpeed(fltAnimationSpeed);
	
	layoutMainCompact.gotoTarget();
	groupMainCompactDrawerTop.gotoTarget();
	groupMainCompactDrawerSongInfo.gotoTarget();
	
	intMainCompactDrawerState = intDrawerState;
	System.setPrivateInt(System.getSkinName(), "MainCompactDrawerState", intMainCompactDrawerState);
}

layoutMainCompact.onTargetReached() {
	if (intMainCompactDrawerState > 0) {
		groupMainCompactDrawerVisualizers.show();
		groupMainCompactDrawerVisualizers.setTargetA(255);
		groupMainCompactDrawerVisualizers.setTargetSpeed(0.5);
		groupMainCompactDrawerVisualizers.gotoTarget();
	}
}

groupMainCompactDrawerVisualizers.onTargetReached() {
	if (groupMainCompactDrawerVisualizers.getAlpha() == 0) {
		groupMainCompactDrawerVisualizers.hide();
	}
}

groupMainCompactDrawerSongInfo.onTargetReached() {
	if (groupMainCompactDrawerSongInfo.getAlpha() == 0) {
		groupMainCompactDrawerSongInfo.hide();
	}
}