#include "../../../lib/std.mi"
#include "utility.m"

Global Group groupScript;
Global Button buttonMain;
Global Layer layerButtonNormal;
Global Layer layerButtonHover;
Global Layer layerButtonDown;

Global Boolean boolIsMouseOver;
Global Boolean boolIsMouseDown;

Global Float fltFadeSpeed;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	buttonMain = groupScript.findObject("fadebutton.button");
	layerButtonNormal = groupScript.findObject("fadebutton.normal");
	layerButtonHover = groupScript.findObject("fadebutton.hover");
	layerButtonDown = groupScript.findObject("fadebutton.down");
	
	layerButtonNormal.show();
	layerButtonHover.setAlpha(0);
	layerButtonDown.setAlpha(0);
	
	fltFadeSpeed = 0.25;
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "action") buttonMain.setXMLParam("action", strValue);
	if (System.strLower(strParam) == "tooltip") buttonMain.setXMLParam("tooltip", strValue);
	if (System.strLower(strParam) == "image") layerButtonNormal.setXMLParam("image", strValue);
	if (System.strLower(strParam) == "hoverimage") layerButtonHover.setXMLParam("image", strValue);
	if (System.strLower(strParam) == "downimage") layerButtonDown.setXMLParam("image", strValue);
	if (System.strLower(strParam) == "fadespeed") fltFadeSpeed = System.stringToFloat(strValue);
}

buttonMain.onEnterArea() {
	animateGuiObjectAlpha(layerButtonHover, 255, fltFadeSpeed);
	boolIsMouseOver = true;
}

buttonMain.onLeaveArea() {
	if (!boolIsMouseDown) {
		animateGuiObjectAlpha(layerButtonHover, 0, fltFadeSpeed);
	}
	boolIsMouseOver = false;
}

buttonMain.onLeftButtonDown(Int intX, Int intY) {
	layerButtonNormal.setAlpha(0);
	layerButtonHover.setAlpha(0);
	layerButtonDown.setAlpha(255);
	boolIsMouseDown = true;
}

buttonMain.onLeftButtonUp(Int intX, Int intY) {
	animateGuiObjectAlpha(layerButtonDown, 0, fltFadeSpeed);
	animateGuiObjectAlpha(layerButtonNormal, 255, fltFadeSpeed);
	if (boolIsMouseOver) {
		animateGuiObjectAlpha(layerButtonHover, 255, fltFadeSpeed);
	}
	boolIsMouseDown = false;
}