#include "../../../lib/std.mi"
#include "../../../lib/config.mi"
#include "utility.m"

Function syncStateImage(Int intState, Boolean boolAnimate);
Function ConfigAttribute getNStatesConfigAttribute(String strCFGAttrib);

Global Group groupScript;
Global ToggleButton buttonMain;
Global ToggleButton buttonMainNStates;
Global Layer layerButtonA;
Global Layer layerButtonB;
Global String strStateType;
Global String strStateImages;
Global Boolean boolInitialized;
Global Boolean boolDebug;
Global ConfigAttribute configAttributeNState;

Global Float fltFadeSpeed;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	
	layerButtonA = groupScript.findObject("fadetogglebutton.a");
	layerButtonB = groupScript.findObject("fadetogglebutton.b");
	
	layerButtonA.setAlpha(0);
	layerButtonB.setAlpha(0);
	
	fltFadeSpeed = 0.25;
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "statetype") {
		strStateType = System.strLower(strValue);
		if (strStateType == "togglebutton") { buttonMain = groupScript.findObject("fadetogglebutton.togglebutton"); }
		if (strStateType == "nstatesbutton") { buttonMain = groupScript.findObject("fadetogglebutton.nstatesbutton"); }
		buttonMain.show();
	}
	if (System.strLower(strParam) == "action") buttonMain.setXMLParam("action", strValue);
	if (System.strLower(strParam) == "param") buttonMain.setXMLParam("param", strValue);
	if (System.strLower(strParam) == "button_cfgattrib") buttonMain.setXMLParam("cfgattrib", strValue);
	if (System.strLower(strParam) == "button_cfgvals") buttonMain.setXMLParam("cfgvals", strValue);
	if (System.strLower(strParam) == "button_nstates") buttonMain.setXMLParam("nstates", strValue);
	if (System.strLower(strParam) == "button_tooltip") buttonMain.setXMLParam("tooltip", strValue);
	if (System.strLower(strParam) == "stateimages") strStateImages = System.strLower(strValue);
	if (System.strLower(strParam) == "debug") boolDebug = (strValue == "1");
	
	if (buttonMain != NULL && boolInitialized != true && strStateImages != "") {
		if (strStateType == "togglebutton") {
			if (buttonMain.getXMLParam("cfgattrib") != "" || buttonMain.getXMLParam("action") != "") {
				buttonMain.onActivate(buttonMain.getActivated());
				boolInitialized = true;
			}
		} else if (strStateType == "nstatesbutton") {
			if (buttonMain.getXMLParam("cfgattrib") != "" && buttonMain.getXMLParam("cfgvals") != "" && buttonMain.getXMLParam("nstates") != "") {
				configAttributeNState = getNStatesConfigAttribute(buttonMain.getXMLParam("cfgattrib"));
				syncStateImage(System.stringToInteger(configAttributeNState.getData()), false);
				boolInitialized = true;
			}
		}
	}
}

buttonMain.onActivate(Int intState) {
	syncStateImage(intState, true);
}

configAttributeNState.onDataChanged() {
	syncStateImage(System.stringToInteger(configAttributeNState.getData()), true);
}

syncStateImage(Int intState, Boolean boolAnimate) {
	String strTokenState;
	String strTokenStateValue;
	String strTokenStateImage;
	for (Int i = 0; i <= strCharCount(strStateImages, ";"); i++) {
		strTokenState = System.getToken(strStateImages, ";", i);
		strTokenStateValue = System.getToken(strTokenState, ":", 0);
		strTokenStateImage = System.getToken(strTokenState, ":", 1);
		if (strTokenStateValue == System.integerToString(intState)) {
			if (strTokenStateImage != layerButtonB.getXMLParam("image")) {
				if (boolAnimate) {
					layerButtonA.setXMLParam("image", layerButtonB.getXMLParam("image"));
					layerButtonA.setAlpha(255);
					layerButtonB.setAlpha(0);
					layerButtonB.setXMLParam("image", strTokenStateImage);
					animateGuiObjectAlpha(layerButtonA, 0, fltFadeSpeed);
					animateGuiObjectAlpha(layerButtonB, 255, fltFadeSpeed);
				} else {
					layerButtonB.setXMLParam("image", strTokenStateImage);
					layerButtonB.setAlpha(255);
				}
			}
		}
	}
}

ConfigAttribute getNStatesConfigAttribute(String strCFGAttrib) {
	if (strStateType == "nstatesbutton") {
		ConfigItem cfgItem;
		cfgItem = Config.getItem(System.getToken(strCFGAttrib, ";", 0));
		if (cfgItem != NULL) {
			return cfgItem.getAttribute(System.getToken(strCFGAttrib, ";", 1));
		}
	}
}