Function initGlobal();
Function unloadGlobal();
Function showActionInfo(String strValue);
Function showSkinOptionsMenu();

Global Container containerMain;
Global Container containerPL;
Global Container containerAVS;
Global Container containerVID;
Global Container containerConfig;
Global Container containerCoverArt;
Global Layout layoutMainNormal;
Global Layout layoutMainCompact;
Global Layout layoutMainShade;
Global Layout layoutPLNormal;
Global Layout layoutPLShade;
Global Layout layoutAVSNormal;
Global Layout layoutVIDNormal;
Global Layout layoutConfigNormal;
Global Layout layoutCoverArtNormal;
Global Text textNormalSongInfo;
Global Text textCompactSongInfo;
Global Text textShadeSongInfo;
Global Text textNormalActionInfo;
Global Text textCompactActionInfo;
Global Text textShadeActionInfo;
Global Text textPLShadeSongInfo;
Global Timer timerSongTicker;
Global Boolean boolReleaseSongTicker;

initGlobal() {
	containerMain = System.getContainer("main");
	containerPL = System.getContainer("pledit");
	containerAVS = System.getContainer("avs_window");
	containerVID = System.getContainer("video");
	containerConfig = System.getContainer("config");
	containerCoverArt = System.getContainer("coverart");
	
	layoutMainNormal = containerMain.getLayout("normal");
	layoutMainCompact = containerMain.getLayout("compact");
	layoutMainShade = containerMain.getLayout("shade");
	layoutPLNormal = containerPL.getLayout("normal");
	layoutPLShade = containerPL.getLayout("shade");
	layoutAVSNormal = containerAVS.getLayout("normal");
	layoutVIDNormal = containerVID.getLayout("normal");
	layoutConfigNormal = containerConfig.getLayout("normal");
	layoutCoverArtNormal = containerCoverArt.getLayout("normal");
	
	textNormalSongInfo = layoutMainNormal.findObject("player.songname");
	textCompactSongInfo = layoutMainCompact.findObject("player.songname");
	textShadeSongInfo = layoutMainShade.findObject("player.songname");
	textNormalActionInfo = layoutMainNormal.findObject("player.actioninfo");
	textCompactActionInfo = layoutMainCompact.findObject("player.actioninfo");
	textShadeActionInfo = layoutMainShade.findObject("player.actioninfo");
	textPLShadeSongInfo = layoutPLShade.findObject("pledit.songname");
	
	textNormalActionInfo.hide();
	textCompactActionInfo.hide();
	textShadeActionInfo.hide();
	
	timerSongTicker = new Timer;
	timerSongTicker.setDelay(1000);
	boolReleaseSongTicker = true;
	
	layoutMainNormal.resize(layoutMainNormal.getLeft(), layoutMainNormal.getTop(), System.stringToInteger(layoutMainNormal.getXMLParam("w")), System.stringToInteger(layoutMainNormal.getXMLParam("h")));
	layoutMainCompact.resize(layoutMainCompact.getLeft(), layoutMainCompact.getTop(), System.stringToInteger(layoutMainCompact.getXMLParam("w")), System.stringToInteger(layoutMainCompact.getXMLParam("h")));
}

unloadGlobal() {
	delete timerSongTicker;
}

timerSongTicker.onTimer() {
	if (boolReleaseSongTicker) {
		textNormalActionInfo.hide();
		textCompactActionInfo.hide();
		textShadeActionInfo.hide();
		textNormalSongInfo.show();
		textCompactSongInfo.show();
		textShadeSongInfo.show();
		timerSongTicker.stop();
	}
}

showActionInfo(String strValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	
	textNormalSongInfo.hide();
	textNormalActionInfo.show();
	textNormalActionInfo.setText(strValue);
	
	textCompactSongInfo.hide();
	textCompactActionInfo.show();
	textCompactActionInfo.setText(strValue);
	
	textShadeSongInfo.hide();
	textShadeActionInfo.show();
	textShadeActionInfo.setText(strValue);
}

showSkinOptionsMenu() {
	PopupMenu popupMenuSkinOptions = new PopupMenu;
	PopupMenu popupMenuNotifierOptions = new PopupMenu;
	PopupMenu popupMenuNotifierHoldTime = new PopupMenu;
	PopupMenu popupMenuDrawerOptions = new PopupMenu;
	PopupMenu popupMenuTooltipOptions = new PopupMenu;
	
	Boolean boolScrollTicker = System.stringToInteger(configAttribute_textScrolling.getData());
	Boolean boolShowExtraInfo = System.stringToInteger(configAttribute_showExtraInfo.getData());
	Boolean boolShowLogoOnShade = System.stringToInteger(configAttribute_showLogoOnShade.getData());
	Boolean boolShowScanlineEffect = System.stringToInteger(configAttribute_scanlineEffect.getData());
	Boolean boolAlwaysOnTop = System.stringToInteger(configAttribute_alwaysOnTop.getData());
	Boolean boolEnableDesktopAlpha = System.stringToInteger(configAttribute_enableDesktopAlpha.getData());
	Boolean boolDockWindows = System.stringToInteger(configAttribute_dockWindows.getData());
	Boolean boolUnlinkShadePosition = System.stringToInteger(configAttribute_unlinkShadePosition.getData());
	Boolean boolAlternateFonts = System.stringToInteger(configAttribute_alternateFonts.getData());

	Boolean boolAnimateDrawers = System.stringToInteger(configAttribute_drawersAnimate.getData());
	Boolean boolSnapAdjustDockedWindows = System.stringToInteger(configAttribute_drawersSnapAdjust.getData());
	
	Boolean boolNotifierAlways = System.stringToInteger(configAttribute_notifierAlways.getData());
	Boolean boolNotifierWindowshade = System.stringToInteger(configAttribute_notifierWindowshade.getData());
	Boolean boolNotifierMinimized = System.stringToInteger(configAttribute_notifierMinimized.getData());
	Boolean boolNotifierNever = System.stringToInteger(configAttribute_notifierNever.getData());
	Boolean boolNotifierDisableFullscreen = System.stringToInteger(configAttribute_notifierDisableFullscreen.getData());
	Boolean boolNotifierPositionTop = System.stringToInteger(configAttribute_notifierPositionTop.getData());
	Boolean boolNotifierPositionBottom = System.stringToInteger(configAttribute_notifierPositionBottom.getData());
	Boolean boolNotifierPositionLeft = System.stringToInteger(configAttribute_notifierPositionLeft.getData());
	Boolean boolNotifierPositionRight = System.stringToInteger(configAttribute_notifierPositionRight.getData());
	Boolean boolNotifierNoAnimation = System.stringToInteger(configAttribute_notifierNoAnimation.getData());
	Boolean boolNotifierFade = System.stringToInteger(configAttribute_notifierFade.getData());
	Boolean boolNotifierSlideVertical = System.stringToInteger(configAttribute_notifierSlideVertical.getData());
	Boolean boolNotifierSlideHorizontal = System.stringToInteger(configAttribute_notifierSlideHorizontal.getData());
	
	Boolean boolNotifierShowCoverArt = System.stringToInteger(configAttribute_notifierShowCoverArt.getData());
	
	Int intNotifierHoldTime = System.stringToInteger(configAttribute_notifierHoldtime.getData());
	
	Boolean boolEnableTooltips = System.stringToInteger(configAttribute_enableTooltips.getData());
	Boolean boolAlternateTooltips = System.stringToInteger(configAttribute_alternateTooltips.getData());
		
	popupMenuDrawerOptions.addCommand("Animate Drawers",10,boolAnimateDrawers,0);
	popupMenuDrawerOptions.addCommand("SnapAdjust Docked windows",11,boolSnapAdjustDockedWindows,0);
	
	popupMenuNotifierHoldTime.addCommand("0 seconds",21,(intNotifierHoldTime == 0),0);
	popupMenuNotifierHoldTime.addCommand("5 seconds",22,(intNotifierHoldTime == 5000),0);
	popupMenuNotifierHoldTime.addCommand("10 seconds",23,(intNotifierHoldTime == 10000),0);
	popupMenuNotifierHoldTime.addCommand("15 seconds",24,(intNotifierHoldTime == 15000),0);
	popupMenuNotifierHoldTime.addCommand("20 seconds",25,(intNotifierHoldTime == 20000),0);
	
	popupMenuNotifierOptions.addCommand("Show Always",12,boolNotifierAlways,0);
	popupMenuNotifierOptions.addCommand("Show With Shade And When Minimized",13,boolNotifierWindowshade,0);
	popupMenuNotifierOptions.addCommand("Show Only When Minimized",14,boolNotifierMinimized,0);
	popupMenuNotifierOptions.addCommand("Never Show",15,boolNotifierNever,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Show Cover Art",41,boolNotifierShowCoverArt,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Disable In Fullscreen",16,boolNotifierDisableFullscreen,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Appears On Top",34,boolNotifierPositionTop,0);
	popupMenuNotifierOptions.addCommand("Appears On Bottom",35,boolNotifierPositionBottom,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("Appears On Left",17,boolNotifierPositionLeft,0);
	popupMenuNotifierOptions.addCommand("Appears On Right",18,boolNotifierPositionRight,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addCommand("No Animation",37,boolNotifierNoAnimation,0);
	popupMenuNotifierOptions.addCommand("Fade In/Out",36,boolNotifierFade,0);
	popupMenuNotifierOptions.addCommand("Slide Vertically",19,boolNotifierSlideVertical,0);
	popupMenuNotifierOptions.addCommand("Slide Horizontally",20,boolNotifierSlideHorizontal,0);
	popupMenuNotifierOptions.addSeparator();
	popupMenuNotifierOptions.addSubMenu(popupMenuNotifierHoldTime, "Hold Time");
	
	popupMenuSkinOptions.addCommand("Enable Text Scrolling",1,boolScrollTicker,0);
	popupMenuSkinOptions.addCommand("Show Extra Song Info",26,boolShowExtraInfo,0);
	popupMenuSkinOptions.addCommand("Show Logo On Shade",42,boolShowLogoOnShade,0);
	popupMenuSkinOptions.addCommand("Show Scanline Effect",39,boolShowScanlineEffect,0);
	popupMenuSkinOptions.addCommand("Always On Top",2,boolAlwaysOnTop,0);
	popupMenuSkinOptions.addCommand("Enable Desktop Alpha",40,boolEnableDesktopAlpha,0);
	popupMenuSkinOptions.addCommand("Dock Windows",4,boolDockWindows,0);
	popupMenuSkinOptions.addCommand("Unlink Shade Position",5,boolUnlinkShadePosition,0);
	popupMenuSkinOptions.addCommand("Alternate Fonts",6,boolAlternateFonts,0);
	popupMenuSkinOptions.addSubMenu(popupMenuNotifierOptions, "Notifications");
	popupMenuSkinOptions.addSubMenu(popupMenuDrawerOptions, "Drawers");
	
	popupMenuTooltipOptions.addCommand("Enable Tooltips",3,boolEnableTooltips,0);
	popupMenuTooltipOptions.addCommand("Alternate Tooltips",38,boolAlternateTooltips,0);
	popupMenuSkinOptions.addSubMenu(popupMenuTooltipOptions, "Tooltips");
	
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 1);
	Int intSelectedOption = popupMenuSkinOptions.popAtMouse();
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 0);
	
	if (intSelectedOption == 1) configAttribute_textScrolling.setData(System.integerToString(!boolScrollTicker));
	else if (intSelectedOption == 2) configAttribute_alwaysOnTop.setData(System.integerToString(!boolAlwaysOnTop));
	else if (intSelectedOption == 3) configAttribute_enableTooltips.setData(System.integerToString(!boolEnableTooltips));
	else if (intSelectedOption == 4) configAttribute_dockWindows.setData(System.integerToString(!boolDockWindows));
	else if (intSelectedOption == 5) configAttribute_unlinkShadePosition.setData(System.integerToString(!boolUnlinkShadePosition));
	else if (intSelectedOption == 6) configAttribute_alternateFonts.setData(System.integerToString(!boolAlternateFonts));
	else if (intSelectedOption == 10) configAttribute_drawersAnimate.setData(System.integerToString(!boolAnimateDrawers));
	else if (intSelectedOption == 11) configAttribute_drawersSnapAdjust.setData(System.integerToString(!boolSnapAdjustDockedWindows));
	else if (intSelectedOption == 12) configAttribute_notifierAlways.setData("1");
	else if (intSelectedOption == 13) configAttribute_notifierWindowshade.setData("1");
	else if (intSelectedOption == 14) configAttribute_notifierMinimized.setData("1");
	else if (intSelectedOption == 15) configAttribute_notifierNever.setData("1");
	else if (intSelectedOption == 16) configAttribute_notifierDisableFullscreen.setData(System.integerToString(!boolNotifierDisableFullscreen));
	else if (intSelectedOption == 17) configAttribute_notifierPositionLeft.setData(System.integerToString(!boolNotifierPositionLeft));
	else if (intSelectedOption == 18) configAttribute_notifierPositionRight.setData(System.integerToString(!boolNotifierPositionRight));
	else if (intSelectedOption == 19) configAttribute_notifierSlideVertical.setData(System.integerToString(!boolNotifierSlideVertical));
	else if (intSelectedOption == 20) configAttribute_notifierSlideHorizontal.setData(System.integerToString(!boolNotifierSlideHorizontal));
	else if (intSelectedOption == 21) configAttribute_notifierHoldtime.setData("0");
	else if (intSelectedOption == 22) configAttribute_notifierHoldtime.setData("5000");
	else if (intSelectedOption == 23) configAttribute_notifierHoldtime.setData("10000");
	else if (intSelectedOption == 24) configAttribute_notifierHoldtime.setData("15000");
	else if (intSelectedOption == 25) configAttribute_notifierHoldtime.setData("20000");
	else if (intSelectedOption == 26) configAttribute_showExtraInfo.setData(System.integerToString(!boolShowExtraInfo));
	else if (intSelectedOption == 34) configAttribute_notifierPositionTop.setData(System.integerToString(!boolNotifierPositionTop));
	else if (intSelectedOption == 35) configAttribute_notifierPositionBottom.setData(System.integerToString(!boolNotifierPositionBottom));
	else if (intSelectedOption == 36) configAttribute_notifierFade.setData(System.integerToString(!boolNotifierFade));
	else if (intSelectedOption == 37) configAttribute_notifierNoAnimation.setData(System.integerToString(!boolNotifierNoAnimation));
	else if (intSelectedOption == 38) configAttribute_alternateTooltips.setData(System.integerToString(!boolAlternateTooltips));
	else if (intSelectedOption == 39) configAttribute_scanlineEffect.setData(System.integerToString(!boolShowScanlineEffect));
	else if (intSelectedOption == 40) configAttribute_enableDesktopAlpha.setData(System.integerToString(!boolEnableDesktopAlpha));
	else if (intSelectedOption == 41) configAttribute_notifierShowCoverArt.setData(System.integerToString(!boolNotifierShowCoverArt));
	else if (intSelectedOption == 42) configAttribute_showLogoOnShade.setData(System.integerToString(!boolShowLogoOnShade));
	
	delete popupMenuNotifierHoldTime;
	delete popupMenuNotifierOptions;
	delete popupMenuDrawerOptions;
	delete popupMenuTooltipOptions;
	delete popupMenuSkinOptions;
	
	complete;
}