#include "../../../lib/std.mi"
#include "attribs.m"

Function scanlineStart();

Global Group groupScript;
Global Layer layerScanline;
Global Int intScanlineRange = 0;
Global Int intScanlineHeight;
Global Float fltScanlineSpeed = 0;

System.onScriptLoaded() {
	initAttribs();
	
	groupScript = System.getScriptGroup();
	layerScanline = groupScript.findobject("scanline.background");
	layerScanline.hide();
	intScanlineHeight = 7;
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "range") intScanlineRange = System.stringToInteger(strValue);
	if (System.strLower(strParam) == "speed") fltScanlineSpeed = System.stringToFloat(strValue);
	if (intScanlineRange != 0 && fltScanlineSpeed != 0) scanlineStart();
}

layerScanline.onTargetReached() {
	layerScanline.hide();
	scanlineStart();
}

configAttribute_scanlineEffect.onDataChanged() {
	scanlineStart();
}

scanlineStart() {
	if (configAttribute_scanlineEffect.getData() == "1") {
		layerScanline.show();
		layerScanline.setXMLParam("y", "-" + System.integerToString(intScanlineHeight));
		layerScanline.setTargetY(intScanlineRange);
		layerScanline.setTargetSpeed(fltScanlineSpeed);
		layerScanline.gotoTarget();
	}
}