Function initSeek();
Function unloadSeek();
Function setSeekAnimation(Int intPosition, Layer layerSeek);
Function updateSeekGhost(Int intPosX, Int intPosY, Layer layerSeek, Map mapSeek);
Function updateSeek(Int intPosX, Int intPosY, Map mapSeek);

Function layerSeekOnLeftButtonDownUtil(Int intPosX, Int intPosY, AnimatedLayer layerSeek, Map mapSeek);
Function layerSeekOnLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeek);
Function layerSeekonMouseMoveUtil(Int intPosX, Int intPosY, AnimatedLayer layerSeek, Map mapSeek);

Global AnimatedLayer layerMainNormalSeek;
Global AnimatedLayer layerMainCompactSeek;
Global Map mapMainNormalSeek;
Global Map mapMainCompactSeek;
Global Boolean boolSeekChanging;
Global Timer timerSeek;

initSeek() {
	layerMainNormalSeek = layoutMainNormal.findObject("player.seek.progress");
	layerMainCompactSeek = layoutMainCompact.findObject("player.seek.progress");
	
	mapMainNormalSeek = new Map;
	mapMainNormalSeek.loadMap("player.normal.map.seek");
	
	mapMainCompactSeek = new Map;
	mapMainCompactSeek.loadMap("player.compact.map.seek");	
	
	timerSeek = new Timer;
	timerSeek.setDelay(750);
	
	if (System.getPlayItemString() != "") {
		setSeekAnimation((System.getPosition() / System.getPlayItemLength()) * 255, layerMainNormalSeek);
		setSeekAnimation((System.getPosition() / System.getPlayItemLength()) * 255, layerMainCompactSeek);
		timerSeek.start();
	} else {
		setSeekAnimation(0, layerMainNormalSeek);
		setSeekAnimation(0, layerMainCompactSeek);
	}
}

unloadSeek() {
	timerSeek.stop();
	delete timerSeek;
	delete mapMainNormalSeek;
	delete mapMainCompactSeek;
}

timerSeek.onTimer() {
	Int intPostition = (System.getPosition() / System.getPlayItemLength()) * 255;
	setSeekAnimation(intPostition, layerMainNormalSeek);
	setSeekAnimation(intPostition, layerMainCompactSeek);
}

layerSeekOnLeftButtonDownUtil(Int intPosX, Int intPosY, AnimatedLayer layerSeek, Map mapSeek) {
	timerSeek.stop();
	boolSeekChanging = true;
	boolReleaseSongTicker = false;
	updateSeekGhost(intPosX, intPosY, layerSeek, mapSeek);
}

layerSeekOnLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeek) {
	timerSeek.start();
	if (boolSeekChanging) {
		boolSeekChanging = false;
		boolReleaseSongTicker = true;
		updateSeek(intPosX, intPosY, mapSeek);
	}
}

layerSeekonMouseMoveUtil(Int intPosX, Int intPosY, AnimatedLayer layerSeek, Map mapSeek) {
	if (boolSeekChanging) {
		updateSeekGhost(intPosX, intPosY, layerSeek, mapSeek);
	}
}

layerMainNormalSeek.onLeftButtonDown(Int intPosX, Int intPosY) { layerSeekOnLeftButtonDownUtil(intPosX, intPosY, layerMainNormalSeek, mapMainNormalSeek); }
layerMainCompactSeek.onLeftButtonDown(Int intPosX, Int intPosY) { layerSeekOnLeftButtonDownUtil(intPosX, intPosY, layerMainCompactSeek, mapMainCompactSeek); }

layerMainNormalSeek.onLeftButtonUp(Int intPosX, Int intPosY) { layerSeekOnLeftButtonUpUtil(intPosX, intPosY, mapMainNormalSeek); }
layerMainCompactSeek.onLeftButtonUp(Int intPosX, Int intPosY) { layerSeekOnLeftButtonUpUtil(intPosX, intPosY, mapMainCompactSeek); }

layerMainNormalSeek.onMouseMove(Int intPosX, Int intPosY) { layerSeekonMouseMoveUtil(intPosX, intPosY, layerMainNormalSeek, mapMainNormalSeek); }
layerMainCompactSeek.onMouseMove(Int intPosX, Int intPosY) { layerSeekonMouseMoveUtil(intPosX, intPosY, layerMainCompactSeek, mapMainCompactSeek); }

setSeekAnimation(Int intPosition, AnimatedLayer layerSeek) {
	if (System.getPlayItemLength() > 0) {
		Int intFrame = (intPosition * (layerSeek.getLength() - 1)) / 255;
		if (intPosition > 0 && intPosition != 255) {
			intFrame = intFrame + 1;
		} else if (intPosition == 0) {
			intFrame = 1;
		}
		layerSeek.gotoFrame(intFrame);
	} else {
		layerSeek.gotoFrame(0);
	}
}

updateSeekGhost(Int intPosX, Int intPosY, AnimatedLayer layerSeek, Map mapSeek) {
	if (System.getPlayItemLength() > 0) {
		Int intNewValue = mapSeek.getValue(intPosX, intPosY);
		Float floatPositionPercentage = intNewValue / 255 * 100;
		Float floatPlayItemLength = System.getPlayItemLength();
		Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
		setSeekAnimation(intNewValue, layerSeek);
		showActionInfo("Seek To: " + System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
	}
}

updateSeek(Int intPosX, Int intPosY, Map mapSeek) {
	if (System.getPlayItemLength() > 0) {
		Int intNewPosition = mapSeek.getValue(intPosX, intPosY);
		System.seekTo(System.getPlayItemLength() * (intNewPosition / 255));
	}
}