Function initShadeSize();
Function setShadeObjects(Int intW);

Global ToggleButton buttonMainShadeDisplayExpand;
Global Float fltMainShadeExpandAnimSpeed;
Global Int intMainShadeLogoOffset;

Global Group groupMainShadeControlButtons;
Global Group groupMainShadeWindowButtons;
Global Group groupMainShadeOptionButtons;
Global Group groupMainShadeDisplay;
Global Group groupMainShadeDisplayText;
Global Group groupMainShadeDisplayVis;
Global Group groupMainShadeDisplayOptions;
Global Group groupMainShadeLogo;

initShadeSize() {
	buttonMainShadeDisplayExpand = layoutMainShade.findObject("player.button.expand");
	
	groupMainShadeControlButtons = layoutMainShade.findObject("player.shade.group.1");
	groupMainShadeWindowButtons = layoutMainShade.findObject("player.shade.group.2");
	groupMainShadeOptionButtons = layoutMainShade.findObject("player.shade.group.3");
	groupMainShadeDisplay = layoutMainShade.findObject("player.shade.group.display");
	groupMainShadeDisplayText = layoutMainShade.findObject("player.shade.group.display.text");
	groupMainShadeDisplayVis = layoutMainShade.findObject("player.shade.group.display.visualizer");
	groupMainShadeDisplayOptions = layoutMainShade.findObject("player.shade.group.display.options");
	groupMainShadeLogo = layoutMainShade.findObject("player.shade.group.logo");
	
	fltMainShadeExpandAnimSpeed = 0.75;
	buttonMainShadeDisplayExpand.onToggle(System.getPrivateInt(System.getSkinName(), "MainShadeOptionsIsCollapsed", 1));
	buttonMainShadeDisplayExpand.setActivatedNoCallback(System.getPrivateInt(System.getSkinName(), "MainShadeOptionsIsCollapsed", 1));
	
	setShadeObjects(layoutMainShade.getWidth());
}

layoutMainShade.onResize(Int intX, Int intY, Int intW, Int intH) {
	setShadeObjects(layoutMainShade.getWidth());
}

buttonMainShadeDisplayExpand.onToggle(Boolean boolCollapse) {
	if (boolCollapse) {
		if (groupMainShadeDisplayVis.isVisible() == 1) {
			groupMainShadeDisplayText.setTargetW(-86);
		} else {
			groupMainShadeDisplayText.setTargetW(-22);
		}
		groupMainShadeDisplayVis.setTargetX(-74);
		groupMainShadeDisplayOptions.setTargetX(-14);
	} else {
		if (groupMainShadeDisplayVis.isVisible() == 1) {
			groupMainShadeDisplayText.setTargetW(-157);
		} else {
			groupMainShadeDisplayText.setTargetW(-93);
		}
		groupMainShadeDisplayVis.setTargetX(-145);
		groupMainShadeDisplayOptions.setTargetX(-85);
	}
	groupMainShadeDisplayText.setTargetSpeed(fltMainShadeExpandAnimSpeed);
	groupMainShadeDisplayVis.setTargetSpeed(fltMainShadeExpandAnimSpeed);
	groupMainShadeDisplayOptions.setTargetSpeed(fltMainShadeExpandAnimSpeed);
	
	groupMainShadeDisplayText.gotoTarget();
	groupMainShadeDisplayVis.gotoTarget();
	groupMainShadeDisplayOptions.gotoTarget();
	
	System.setPrivateInt(System.getSkinName(), "MainShadeOptionsIsCollapsed", boolCollapse);
}

groupMainShadeDisplayOptions.onTargetReached() {
	setShadeObjects(layoutMainShade.getWidth());
}

setShadeObjects(Int intW) {
	if (configAttribute_showLogoOnShade.getData() == "1") {
		intMainShadeLogoOffset = 0;
		groupMainShadeLogo.show();
	} else {
		intMainShadeLogoOffset = 80;
		groupMainShadeLogo.hide();
	}
	
	groupMainShadeWindowButtons.hide();
	groupMainShadeOptionButtons.hide();
	groupMainShadeDisplayVis.hide();
	
	layoutMainShade.setXMLParam("minimum_w", System.integerToString(483 - intMainShadeLogoOffset));
	if (layoutMainShade.getWidth() < System.stringToInteger(layoutMainShade.getXMLParam("minimum_w"))) {
		layoutMainShade.resize(layoutMainShade.getLeft(), layoutMainShade.getTop(), System.stringToInteger(layoutMainShade.getXMLParam("minimum_w")), layoutMainShade.getHeight());
	}
	groupMainShadeControlButtons.setXMLParam("w", System.integerToString(221 - intMainShadeLogoOffset));
	groupMainShadeDisplay.setXMLParam("x", System.integerToString(221 - intMainShadeLogoOffset));
	groupMainShadeDisplay.setXMLParam("w", System.integerToString(-310 + intMainShadeLogoOffset));
	if (System.getPrivateInt(System.getSkinName(), "MainShadeOptionsIsCollapsed", 1) == 1) {
		groupMainShadeDisplayText.setXMLParam("w", "-22");
	} else {
		groupMainShadeDisplayText.setXMLParam("w", "-93");
	}
	
	if (intW > 550) {
		groupMainShadeWindowButtons.show();
		groupMainShadeWindowButtons.setXMLParam("x", System.integerToString(221 - intMainShadeLogoOffset));
		groupMainShadeDisplay.setXMLParam("x", System.integerToString(292 - intMainShadeLogoOffset));
		groupMainShadeDisplay.setXMLParam("w", System.integerToString(-381 + intMainShadeLogoOffset));
		if (intW > 600) {
			groupMainShadeOptionButtons.show();
			groupMainShadeOptionButtons.setXMLParam("x", System.integerToString(292 - intMainShadeLogoOffset));
			groupMainShadeDisplay.setXMLParam("x", System.integerToString(351 - intMainShadeLogoOffset));
			groupMainShadeDisplay.setXMLParam("w", System.integerToString(-440 + intMainShadeLogoOffset));
			if (intW > 700) {
				groupMainShadeDisplayVis.show();
				if (System.getPrivateInt(System.getSkinName(), "MainShadeOptionsIsCollapsed", 1) == 1) {
					groupMainShadeDisplayText.setTargetW(-93);
				} else {
					groupMainShadeDisplayText.setTargetW(-157);
				}
				groupMainShadeDisplayText.setTargetSpeed(0);
				groupMainShadeDisplayText.gotoTarget();
			}
		}
	}
}

configAttribute_showLogoOnShade.onDataChanged() {
	setShadeObjects(layoutMainShade.getWidth());
}