Function initSongInfo();
Function unloadSongInfo();
Function displaySongInfo(String strInfo);
Function displayEmptySongInfo();

Global Text textMainNormalBitrate;
Global Text textMainNormalSamplerate;
Global Layer layerMainNormalChannelsStereo;
Global Layer layerMainNormalChannelsMono;
Global Layer layerMainNormalChannelsInactive;
Global Timer timerSongInfo;

Global Text textMainCompactBitrate;
Global Text textMainCompactSamplerate;
Global Layer layerMainCompactChannelsStereo;
Global Layer layerMainCompactChannelsMono;
Global Layer layerMainCompactChannelsInactive;
Global Timer timerSongInfo;

initSongInfo() {
	textMainNormalBitrate = layoutMainNormal.findObject("player.bitrate");
	textMainNormalSamplerate = layoutMainNormal.findObject("player.samplerate");
	layerMainNormalChannelsStereo = layoutMainNormal.findObject("player.channels.stereo");
	layerMainNormalChannelsMono = layoutMainNormal.findObject("player.channels.mono");
	layerMainNormalChannelsInactive = layoutMainNormal.findObject("player.channels.inactive");
	
	textMainCompactBitrate = layoutMainCompact.findObject("player.bitrate");
	textMainCompactSamplerate = layoutMainCompact.findObject("player.samplerate");
	layerMainCompactChannelsStereo = layoutMainCompact.findObject("player.channels.stereo");
	layerMainCompactChannelsMono = layoutMainCompact.findObject("player.channels.mono");
	layerMainCompactChannelsInactive = layoutMainCompact.findObject("player.channels.inactive");
	
	timerSongInfo = new Timer;
	timerSongInfo.setDelay(50);
}

unloadSongInfo() {
	delete timerSongInfo;
}

timerSongInfo.onTimer() {
	String strInfo = System.getSongInfoText();
	if (strInfo != "") {
		timerSongInfo.setDelay(1000);
		displaySongInfo(strInfo);
	} else {
		displayEmptySongInfo();
	}
}

displaySongInfo(String strInfo) {
	Int intIndex;
	String strToken;
	String strValue;
	
	for (Int i = 0; i <= strCharCount(strInfo, " "); i++) {
		strToken = System.getToken(strInfo, " ", i);
		
		intIndex = System.strSearch(System.strLower(strToken), "kbps");
		if (intIndex > 0) {
			strValue = System.strMid(strToken, 0, intIndex);
			textMainNormalBitrate.setText(System.strRight("0000" + strValue, 4));
			textMainCompactBitrate.setText(System.strRight("0000" + strValue, 4));
		}
		
		intIndex = System.strSearch(System.strLower(strToken), "khz");
		if (intIndex > 0) {
			strValue = System.strMid(strToken, 0, intIndex);
			intIndex = System.strSearch(strValue, ".");
			if (intIndex > 0) strValue = System.strMid(strValue, 0, intIndex);
			textMainNormalSamplerate.setText(strValue);
			textMainCompactSamplerate.setText(strValue);
		}
	}
	
	if (System.strSearch(System.strUpper(strInfo), "MONO") != -1) {
		layerMainNormalChannelsInactive.hide();
		layerMainNormalChannelsStereo.hide();
		layerMainNormalChannelsMono.show();
		
		layerMainCompactChannelsInactive.hide();
		layerMainCompactChannelsStereo.hide();
		layerMainCompactChannelsMono.show();
	} else if (System.strSearch(System.strUpper(strInfo), "STEREO") != -1) {
		layerMainNormalChannelsInactive.hide();
		layerMainNormalChannelsMono.hide();
		layerMainNormalChannelsStereo.show();
		
		layerMainCompactChannelsInactive.hide();
		layerMainCompactChannelsMono.hide();
		layerMainCompactChannelsStereo.show();
	} else {
		layerMainNormalChannelsMono.hide();
		layerMainNormalChannelsStereo.hide();
		layerMainNormalChannelsInactive.show();
		
		layerMainCompactChannelsMono.hide();
		layerMainCompactChannelsStereo.hide();
		layerMainCompactChannelsInactive.show();
	}
}

displayEmptySongInfo() {
	textMainNormalBitrate.setText("0000");
	textMainNormalSamplerate.setText("00");
	
	textMainCompactBitrate.setText("0000");
	textMainCompactSamplerate.setText("00");
	
	layerMainNormalChannelsMono.hide();
	layerMainNormalChannelsStereo.hide();
	layerMainNormalChannelsInactive.show();
	
	layerMainCompactChannelsMono.hide();
	layerMainCompactChannelsStereo.hide();
	layerMainCompactChannelsInactive.show();
}