Function initVolume();
Function unloadVolume();
Function volumeUpdate();
Function volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost);
Function volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost);
Function volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Int intVolume);
Function layerVolumeOnLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost);
Function layerVolumeOnLeftButtonUpUtil(Int intPosX, Int intPosY);
Function layerVolumeOnMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost);

Global Layer layerNormalVolume;
Global Layer layerNormalVolumeGhost;
Global Map mapMainNormalVolumeLevel;
Global Map mapMainNormalVolumeRegion;

Global Layer layerCompactVolume;
Global Layer layerCompactVolumeGhost;
Global Map mapMainCompactVolumeLevel;
Global Map mapMainCompactVolumeRegion;

Global Region regionVolume;
Global Int intVolumeClicked;

initVolume() {
	layerNormalVolume = layoutMainNormal.findObject("player.background.drawer.display.volume.track");
	layerNormalVolumeGhost = layoutMainNormal.findObject("player.background.drawer.display.volume");
	
	layerCompactVolume = layoutMainCompact.findObject("player.background.display.volume.track");
	layerCompactVolumeGhost = layoutMainCompact.findObject("player.background.display.volume");
	
	mapMainNormalVolumeLevel = new Map;
	mapMainNormalVolumeRegion = new Map;
	mapMainCompactVolumeLevel = new Map;
	mapMainCompactVolumeRegion = new Map;
	
	mapMainNormalVolumeLevel.loadMap("player.normal.map.volume");
	mapMainNormalVolumeRegion.loadMap("player.normal.map.volume.region");
	
	mapMainCompactVolumeLevel.loadMap("player.compact.map.volume");
	mapMainCompactVolumeRegion.loadMap("player.compact.map.volume.region");
	
	regionVolume = new Region;
	
	volumeUpdate();
}

unloadVolume() {
	delete mapMainNormalVolumeLevel;
	delete mapMainNormalVolumeRegion;
	delete mapMainCompactVolumeLevel;
	delete mapMainCompactVolumeRegion;
	delete regionVolume;
}

volumeUpdate() {
	volumeUpdateUtil(mapMainNormalVolumeRegion, layerNormalVolumeGhost);
	volumeUpdateUtil(mapMainCompactVolumeRegion, layerCompactVolumeGhost);
}

volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost) {
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, System.getVolume());
}

volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost) {
	Int intVolume = mapVolumeLevel.getValue(intPosX, intPosY);
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, intVolume);
	System.setVolume(intVolume);
}

volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Float intVolume) {
	regionVolume.loadFromMap(mapVolumeRegion, intVolume, 1);
	layerVolumeGhost.setRegion(regionVolume);
}

layerNormalVolume.onLeftButtonDown(Int intPosX, Int intPosY) { layerVolumeOnLeftButtonDownUtil(intPosX, intPosY, mapMainNormalVolumeLevel, mapMainNormalVolumeRegion, layerNormalVolumeGhost); }
layerCompactVolume.onLeftButtonDown(Int intPosX, Int intPosY) { layerVolumeOnLeftButtonDownUtil(intPosX, intPosY, mapMainCompactVolumeLevel, mapMainCompactVolumeRegion, layerCompactVolumeGhost); }
layerVolumeOnLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost) {
	intVolumeClicked = 1;
	boolReleaseSongTicker = false;
	volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost);
}

layerNormalVolume.onMouseMove(Int intPosX, Int intPosY) { layerVolumeOnMouseMoveUtil(intPosX, intPosY, mapMainNormalVolumeLevel, mapMainNormalVolumeRegion, layerNormalVolumeGhost); }
layerCompactVolume.onMouseMove(Int intPosX, Int intPosY) { layerVolumeOnMouseMoveUtil(intPosX, intPosY, mapMainCompactVolumeLevel, mapMainCompactVolumeRegion, layerCompactVolumeGhost); }
layerVolumeOnMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost) {
	if (intVolumeClicked) {
		volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost);
	}
}

layerNormalVolume.onLeftButtonUp(Int intPosX, Int intPosY) { layerVolumeOnLeftButtonUpUtil(intPosX, intPosY); }
layerCompactVolume.onLeftButtonUp(Int intPosX, Int intPosY) { layerVolumeOnLeftButtonUpUtil(intPosX, intPosY); }
layerVolumeOnLeftButtonUpUtil(Int intPosX, Int intPosY) {
	if (!intVolumeClicked) return;
	intVolumeClicked = 0;
	boolReleaseSongTicker = true;
}